//
// Copyright (C) 1999-2006 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCPROCEDURE_H
#define WSCPROCEDURE_H

#include <WScom.h>
class WSCbase;

class WSCprocedure{

  private:
    void* _function;
    char* _func_name;
    char* _prc_name;
    long  _effective_trg_mask; 
    char  _trg;
    unsigned _internal_prc:1;
    unsigned _src_file:1;

  public:
    WSDLEX32 WSCprocedure(char*,long);
    WSDLEX32 virtual ~WSCprocedure();
    WSDLEX32 long setProcName(char*);
    WSDLEX32 long setProc(void*);
    WSDLEX32 long setEffectiveTriggerMask(long);
    WSDLEX32 long setTrigger(long);
    WSDLEX32 long setFunction(void(*)(WSCbase*),char*);
    WSDLEX32 void setInternal(WSCbool);
    WSDLEX32 void setUseFile(WSCbool fl);

    WSDLEX32 char* getProcName();
    WSDLEX32 char* getFunctionName();
    WSDLEX32 void* getProc();
    WSDLEX32 long  getEffectiveTriggerMask();
    WSDLEX32 long  getTrigger();
    WSDLEX32 WSCbool getInternal();
    WSDLEX32 WSCbool getUseFile();
};
extern WSDLEX void WSGFsetProcedureHandler(void* hd);
extern void* WSGFgetProcedureHandler();
#endif
