//
// Copyright (C) 1999-2006 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCCOLOREDITOR_H
#define WSCCOLOREDITOR_H
#include <WScom.h>
#include <WSDappDev.h>
#include <WSCbaseDialog.h>

#define WSCcolorEditor_VER 1010

class WSCvtoggle;
class WSCoption;
class WSCvline;
class WSCbaseDialog;
class WSCform;
class WSCvbtn;
class WSCvlabel;
class WSCvslider;
class WSCvifield;
class WSCmessageDialog;
class WSDcolor;

class WSCcolorEditor :public WSCbaseDialog {

 protected:
  void* _rep_hd;

  WSMFpropertyDef(WSNreplyHandler,void*,_rep_hd);

  WSCform* clearea1;
  WSCvlabel* cledvlab000;
  WSCvslider* cledvsli001;
  WSCvifield* cledvifi001;
  WSCvifield* cledvifi002;
  WSCvifield* cledvifi003;
  WSCvslider* cledvsli002;
  WSCvslider* cledvsli003;
  WSCvslider* cledvsli004;
  WSCvifield* cledvifi004;
  WSCvifield* cledvlab001;
  WSCvlabel* cledvlab003;

  WSDLEX32 void _property_initialize();
  WSDLEX32 void _property_delete();

  WSDLEX32 void _set_color_name(char*);
  static WSDcolor* color;
  long  _slider_not_move;

  WSDLEX32 static void cl_set(WSCbase*);
  WSDLEX32 static void cl_end(WSCbase*);
  WSDLEX32 static void cl_drop(WSCbase*);
  WSDLEX32 static void cl_chop(WSCbase*);
  WSDLEX32 static void cl_if_set0(WSCbase*);
  WSDLEX32 static void cl_if_set1(WSCbase*);
  WSDLEX32 static void cl_if_set2(WSCbase*);
  WSDLEX32 static void cl_if_set3(WSCbase*);
  WSDLEX32 static void cl_ifname_set(WSCbase*);

  WSDLEX32 virtual void onActivate();

 public:
  WSDLEX32 WSCcolorEditor(WSCbase* base,char* name);
  WSDLEX32 virtual ~WSCcolorEditor();
  WSDLEX32 virtual long initialize();
  WSDLEX32 virtual void adjustForm();
  WSDLEX32 virtual void onGuiPolicyChange(long);

  WSDLEX32 char* getColorName();
  WSDLEX32 void  setColorName(char*);

  WSMFguiClassDef(WSCcolorEditor,WSCbaseDialog);
  WSMFversionDef(WSCcolorEditor);
};
extern WSDLEX WSCcolorEditor* WSGIappColorEditor();
#endif
