//
// Copyright (C) 1999-2006 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCCOLORSELECT_H
#define WSCCOLORSELECT_H

#include <WScom.h>
#include <WSCbaseDialog.h>

class WSCscrForm;
class WSCvbtn;
class WSCform;
class WSCvlabel;
class WSCoption;
class WSCbaseDialog;
class WSCvtoggle;
class WSCvifield;
class WSCmessageDialog;
class WSCindexForm;

class WSCcolorSelect            :public WSCbaseDialog {
   
  protected:
    void* _work_proc;
//    WSClistData _label_list;
    WSCform*  _area;
    WSCvbtn*     _set_btn;
    WSCscrForm*  _scr_area;
    WSCscrForm*  _scr_area0;
    WSCscrForm*  _scr_area2;
    WSCvlabel*   _color_show;
    WSCvlabel*   _color_name;
    WSClistData  _user_colors;
    WSClistData  _user_label_list;
    WSCmessageDialog* _message;
    WSCbool       _init;
    WSCindexForm* _index_area;

    WSMFpropertyDef( WSNreplyHandler, void*,      _work_proc ); 

//    short          _table_no;
    WSDLEX32 void updateList();

    WSDLEX32 virtual void setWorkWSNwidth(WSCushort);
    WSDLEX32 virtual void setWorkWSNheight(WSCushort);

WSDLEX32 static void _set_btn_work(WSCbase*);
WSDLEX32 static void _label_push_work(WSCbase*);

WSDLEX32 virtual void onVisibleChange(WSCbool);
WSDLEX32 virtual void onParentVisibleChange(WSCbool);
WSDLEX32 virtual void onResize(WSCrect*);
WSDLEX32 virtual void onActivate();
    WSDLEX32 void _adjust();

    WSDLEX32 static WSCeventProc evprocs[];   
    WSDLEX32 static void _btn1_work(WSCbase*); 
    WSDLEX32 static void _btn2_work(WSCbase*);
    WSDLEX32 static void _btn3_work(WSCbase*);


    WSDLEX32 void _setup_area1(WSCbase*);
    WSDLEX32 void _setup_dbtn(WSCbase*,long,char*,char*,char*);

  public:
    WSDLEX32 WSCcolorSelect(WSCbase*,char*);
    WSDLEX32 virtual ~WSCcolorSelect();

    WSDLEX32 virtual  long initialize();
    WSDLEX32 virtual  void onGuiPolicyChange(long);

    WSDLEX32 char*    getSelectColor();
    WSDLEX32 char*    getSelectTopShadowColor();
    WSDLEX32 char*    getSelectBottomShadowColor();

    WSDLEX32 void addColorEntry(char*);
    WSDLEX32 long delColorEntry(char*);
    WSDLEX32 void updateColorEntry();
    WSDLEX32 void clearColorEntry();

    WSDLEX32 long save(char*);
    WSDLEX32 long load(char*);

    WSMFguiClassDef(WSCcolorSelect,WSCbaseDialog);
};
extern WSDLEX WSCcolorSelect* WSGIappColorSelect();

#endif //WSCCOLORSELECT_H
