//
// Copyright (C) 1999-2006 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSDUNIXTHREAD_H
#define WSDUNIXTHREAD_H

#include <pthread.h>
#include <WSDthread.h>

class WSDunixThread :public WSDthread{

  protected:
    pthread_t _id;
    pthread_mutex_t _mutex;
    long _status;
static void* _thread_start_handler(void*);
  public:
    WSDunixThread();
    virtual ~WSDunixThread();

    virtual long    createThread(void* data);
    virtual long    detachThread();
    virtual long    joinThread(void**);
    virtual long    terminateThread();
    virtual long    getStatus();
    virtual long    execCallback(void*);

    WSMFclassDef(WSDunixThread,WSDthread);
};
struct _internal_thr_data_ {
  WSDunixThread* thr;
  void*         data;
};

#endif
