open Swig
open Mwtlib
open Newwin000
open Startep

let del_pos = (-1, -1)
let del_filter item = item <> del_pos
let p = print_endline

let update_ep obj =
   (* do something *)
   match List.length !inv_list with
   | 0 -> 
      ignore(!newvtim_001 -> "setProperty" ("running", _False));
      ignore(_WSGIappMessageDialog '() ->
                "setProperty" ("labelString", "ʤξǤ"));
      ignore(_WSGIappMessageDialog '() -> "setVisible" (_True));
      ()
   | _ -> (* to next phase *)

   (* key input *)
   let key = get_int (_WSGIappKeyboard '() -> "getKey" ()) in
   if get_int (_WSGIappKeyboard '() -> "isPressed" ()) <> get_int _False then
      begin
      match !my_base with
      | base_x, base_y ->
         if key = get_int _WSK_Right then
            begin
               let nbase_x = base_x + 5 in
               if nbase_x > 380 then
                  my_base := (380, base_y)
               else
                  my_base := (nbase_x, base_y)
            end
         else if key = get_int _WSK_Left then
            begin
               let nbase_x = base_x - 5 in
               if nbase_x < 0 then
                  my_base := (0, base_y)
               else
                  my_base := (nbase_x, base_y)
            end
         else if key = get_int _WSK_space then
            begin
               my_missile := (base_x + 5, base_y) :: !my_missile;
               ignore(_WSGIappKeyboard '() -> "setKey" (0))
            end
      end;

   (* hit check of my_missle vs inv_missile *)
   let map_f_mm pos_mm =
      match pos_mm with
      | mpt_x, mpt_y ->
      let map_f_im pos_im =
         match pos_im with
         | impt_x, impt_y ->
         if (mpt_x - 3 < impt_x) && (impt_x < mpt_x + 3) &&
            (mpt_y - 6 < impt_y) && (impt_y < mpt_y + 3 + 10 - 6)
         then del_pos else pos_im
      in
      let tmp_im = List.rev_map map_f_im !inv_missile in
      if List.mem del_pos tmp_im then
         begin
            inv_missile := List.filter del_filter tmp_im;
            del_pos
         end
      else
         begin
            inv_missile := tmp_im;
            pos_mm
         end
   in
   let tmp_mm = List.rev_map map_f_mm !my_missile in
   if List.mem del_pos tmp_mm
   then my_missile := List.filter del_filter tmp_mm
   else my_missile := tmp_mm;

   (* hit check of my_base and fence vs inv_missile *)
   let alive_flag = ref true in
   let map_f_im pos_im =
      match pos_im with
      | mpt_x, mpt_y ->
      match !my_base with
      | base_x, base_y ->
      if (base_x < mpt_x) && (mpt_x < base_x + 10) &&
         (base_y < mpt_y) && (mpt_y < base_y + 10)
      then alive_flag := false;
      let map_f_fen pos_fen =
         match pos_fen with
         | fpt_x, fpt_y ->
         if (fpt_x < mpt_x) && (mpt_x < fpt_x + 5) &&
            (fpt_y < mpt_y) && (mpt_y < fpt_y + 5)
         then del_pos else pos_fen
      in
      let tmp_fen = List.rev_map map_f_fen !fence_list in
      if List.mem del_pos tmp_fen then
         begin
            fence_list := List.filter del_filter tmp_fen;
            del_pos
         end
      else
         begin
            fence_list := tmp_fen;
            pos_im
         end
   in
   let tmp_im = List.rev_map map_f_im !inv_missile in
   if List.mem del_pos tmp_im
   then inv_missile := List.filter del_filter tmp_im
   else inv_missile := tmp_im;

   match !alive_flag with
   | false ->
      ignore(!newvtim_001 -> "setProperty" ("running", _False));
      ignore(_WSGIappMessageDialog '() ->
                "setProperty" ("labelString", "ʤϤޤ"));
      ignore(_WSGIappMessageDialog '() -> "setVisible" (_True))
   | _ -> (* to next phase *)

   (* hit check of my_missile vs fence and inv *)
   let map_f_mm pos_mm =
      match pos_mm with
      | mpt_x, mpt_y ->
      let map_f_fen pos_fen =
         match pos_fen with
         | fpt_x, fpt_y ->
         if (fpt_x < mpt_x) && (mpt_x < fpt_x + 5) &&
            (fpt_y < mpt_y) && (mpt_y < fpt_y + 5)
         then del_pos else pos_fen
      in
      let tmp_fen = List.rev_map map_f_fen !fence_list in
      let del_exist_fen = List.mem del_pos tmp_fen in
      if del_exist_fen
      then fence_list := List.filter del_filter tmp_fen
      else fence_list := tmp_fen;
      let map_f_inv pos_inv =
         match pos_inv with
         | fpt_x, fpt_y ->
         if (fpt_x < mpt_x) && (mpt_x < fpt_x + 10) &&
            (fpt_y < mpt_y) && (mpt_y < fpt_y + 10)
         then
            begin
               let score = get_int (!newvlab_001 -> "getProperty"
                                                   ("labelString")) in
               ignore (!newvlab_001 -> "setProperty" ("labelString",
                                                     (make_int (score + 10))));
               del_pos
            end
         else pos_inv
      in
      let tmp_inv = List.rev_map map_f_inv !inv_list in
      let del_exist_inv = List.mem del_pos tmp_inv in
      if del_exist_inv
      then inv_list := List.filter del_filter tmp_inv
      else inv_list := tmp_inv;
      if (del_exist_fen || del_exist_inv) then del_pos else pos_mm
   in
   let tmp_mm = List.rev_map map_f_mm !my_missile in
   if List.mem del_pos tmp_mm
   then my_missile := List.filter del_filter tmp_mm
   else my_missile := tmp_mm;

   ignore(!newvdra_001 -> "redraw" ());
   ()

let _ = Callback.register "update_ep" update_ep
